org.jgrapht.graph

## Class GraphUnion<V,E,G extends Graph<V,E>>

- java.lang.Object
- - org.jgrapht.graph.AbstractGraph<V,E>
  - - org.jgrapht.graph.GraphUnion<V,E,G>

- All Implemented Interfaces:
    Serializable, Graph<V,E>
  Direct Known Subclasses:
    DirectedGraphUnion, MixedGraphUnion, UndirectedGraphUnion

      public class GraphUnion<V,E,G extends Graph<V,E>>
      extends AbstractGraph<V,E>
      implements Serializable

  Read-only union of two graphs: G1 and G2. If G1 = (V1, E1) and G2 = (V2, E2) then their union G = (V, E), where V is the union of V1 and V2, and E is the union of E1 and E1.

  `GraphUnion` implements `Graph` interface. `GraphUnion` uses `WeightCombiner` to choose policy for calculating edge weight.

  See Also:
    Serialized Form

- - ### Constructor Summary

    Constructors
    Constructor and Description
    `GraphUnion(G g1, G g2)`
    `GraphUnion(G g1, G g2, WeightCombiner operator)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `E` | `addEdge(V sourceVertex, V targetVertex)` Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
    `boolean` | `addEdge(V sourceVertex, V targetVertex, E e)` Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
    `boolean` | `addVertex(V v)` Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
    `boolean` | `containsEdge(E e)` Returns `true` if this graph contains the specified edge.
    `boolean` | `containsVertex(V v)` Returns `true` if this graph contains the specified vertex.
    `Set<E>` | `edgeSet()` Returns a set of the edges contained in this graph.
    `Set<E>` | `edgesOf(V vertex)` Returns a set of all edges touching the specified vertex.
    `Set<E>` | `getAllEdges(V sourceVertex, V targetVertex)` Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph.
    `E` | `getEdge(V sourceVertex, V targetVertex)` Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph.
    `EdgeFactory<V,E>` | `getEdgeFactory()` Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
    `V` | `getEdgeSource(E e)` Returns the source vertex of an edge.
    `V` | `getEdgeTarget(E e)` Returns the target vertex of an edge.
    `double` | `getEdgeWeight(E e)` Returns the weight assigned to a given edge.
    `G` | `getG1()`
    `G` | `getG2()`
    `boolean` | `removeEdge(E e)` Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
    `E` | `removeEdge(V sourceVertex, V targetVertex)` Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
    `boolean` | `removeVertex(V v)` Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
    `Set<V>` | `vertexSet()` Returns a set of the vertices contained in this graph.

    - ### Methods inherited from class org.jgrapht.graph.AbstractGraph

      `assertVertexExist, containsEdge, equals, hashCode, removeAllEdges, removeAllEdges, removeAllEdges, removeAllVertices, toString, toStringFromSets`

    - ### Methods inherited from class java.lang.Object

      `clone, finalize, getClass, notify, notifyAll, wait, wait, wait`

- - ### Constructor Detail

    - #### GraphUnion

          public GraphUnion(G g1,
                    G g2,
                    WeightCombiner operator)

    - #### GraphUnion

          public GraphUnion(G g1,
                    G g2)

  - ### Method Detail

    - #### getAllEdges

          public Set<E> getAllEdges(V sourceVertex,
                           V targetVertex)

      Description copied from interface: `Graph`
      Returns a set of all edges connecting source vertex to target vertex if such vertices exist in this graph. If any of the vertices does not exist or is `null`, returns `null`. If both vertices exist but no edges found, returns an empty set.

      In undirected graphs, some of the returned edges may have their source and target vertices in the opposite order. In simple graphs the returned set is either singleton set or empty set.

      Specified by:
        `getAllEdges` in interface `Graph<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        a set of all edges connecting source vertex to target vertex.

    - #### getEdge

          public E getEdge(V sourceVertex,
                  V targetVertex)

      Description copied from interface: `Graph`
      Returns an edge connecting source vertex to target vertex if such vertices and such edge exist in this graph. Otherwise returns `null`. If any of the specified vertices is `null` returns `null`

      In undirected graphs, the returned edge may have its source and target vertices in the opposite order.

      Specified by:
        `getEdge` in interface `Graph<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        an edge connecting source vertex to target vertex.

    - #### getEdgeFactory

          public EdgeFactory<V,E> getEdgeFactory()

      Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
      Specified by:
        `getEdgeFactory` in interface `Graph<V,E>`
      Returns:
        the edge factory using which this graph creates new edges.

    - #### addEdge

          public E addEdge(V sourceVertex,
                  V targetVertex)

      Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
      Specified by:
        `addEdge` in interface `Graph<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        The newly created edge if added to the graph, otherwise `null`.
      See Also:
        `Graph.getEdgeFactory()`

    - #### addEdge

          public boolean addEdge(V sourceVertex,
                        V targetVertex,
                        E e)

      Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
      Specified by:
        `addEdge` in interface `Graph<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
        `e` - edge to be added to this graph.
      Returns:
        `true` if this graph did not already contain the specified edge.
      See Also:
        `Graph.addEdge(Object, Object)`, `Graph.getEdgeFactory()`

    - #### addVertex

          public boolean addVertex(V v)

      Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
      Specified by:
        `addVertex` in interface `Graph<V,E>`
      Parameters:
        `v` - vertex to be added to this graph.
      Returns:
        `true` if this graph did not already contain the specified vertex.

    - #### containsEdge

          public boolean containsEdge(E e)

      Description copied from interface: `Graph`
      Returns `true` if this graph contains the specified edge. More formally, returns `true` if and only if this graph contains an edge `e2` such that `e.equals(e2)`. If the specified edge is `null` returns `false`.
      Specified by:
        `containsEdge` in interface `Graph<V,E>`
      Parameters:
        `e` - edge whose presence in this graph is to be tested.
      Returns:
        `true` if this graph contains the specified edge.

    - #### containsVertex

          public boolean containsVertex(V v)

      Description copied from interface: `Graph`
      Returns `true` if this graph contains the specified vertex. More formally, returns `true` if and only if this graph contains a vertex `u` such that `u.equals(v)`. If the specified vertex is `null` returns `false`.
      Specified by:
        `containsVertex` in interface `Graph<V,E>`
      Parameters:
        `v` - vertex whose presence in this graph is to be tested.
      Returns:
        `true` if this graph contains the specified vertex.

    - #### edgeSet

          public Set<E> edgeSet()

      Description copied from interface: `Graph`
      Returns a set of the edges contained in this graph. The set is backed by the graph, so changes to the graph are reflected in the set. If the graph is modified while an iteration over the set is in progress, the results of the iteration are undefined.

      The graph implementation may maintain a particular set ordering (e.g. via `LinkedHashSet`) for deterministic iteration, but this is not required. It is the responsibility of callers who rely on this behavior to only use graph implementations which support it.

      Specified by:
        `edgeSet` in interface `Graph<V,E>`
      Returns:
        a set of the edges contained in this graph.

    - #### edgesOf

          public Set<E> edgesOf(V vertex)

      Description copied from interface: `Graph`
      Returns a set of all edges touching the specified vertex. If no edges are touching the specified vertex returns an empty set.
      Specified by:
        `edgesOf` in interface `Graph<V,E>`
      Parameters:
        `vertex` - the vertex for which a set of touching edges is to be returned.
      Returns:
        a set of all edges touching the specified vertex.

    - #### removeEdge

          public E removeEdge(V sourceVertex,
                     V targetVertex)

      Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
      Specified by:
        `removeEdge` in interface `Graph<V,E>`
      Parameters:
        `sourceVertex` - source vertex of the edge.
        `targetVertex` - target vertex of the edge.
      Returns:
        The removed edge, or `null` if no edge removed.

    - #### removeEdge

          public boolean removeEdge(E e)

      Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
      Specified by:
        `removeEdge` in interface `Graph<V,E>`
      Parameters:
        `e` - edge to be removed from this graph, if present.
      Returns:
        `true` if and only if the graph contained the specified edge.

    - #### removeVertex

          public boolean removeVertex(V v)

      Throws `UnsupportedOperationException`, because `GraphUnion` is read-only.
      Specified by:
        `removeVertex` in interface `Graph<V,E>`
      Parameters:
        `v` - vertex to be removed from this graph, if present.
      Returns:
        `true` if the graph contained the specified vertex; `false` otherwise.

    - #### vertexSet

          public Set<V> vertexSet()

      Description copied from interface: `Graph`
      Returns a set of the vertices contained in this graph. The set is backed by the graph, so changes to the graph are reflected in the set. If the graph is modified while an iteration over the set is in progress, the results of the iteration are undefined.

      The graph implementation may maintain a particular set ordering (e.g. via `LinkedHashSet`) for deterministic iteration, but this is not required. It is the responsibility of callers who rely on this behavior to only use graph implementations which support it.

      Specified by:
        `vertexSet` in interface `Graph<V,E>`
      Returns:
        a set view of the vertices contained in this graph.

    - #### getEdgeSource

          public V getEdgeSource(E e)

      Description copied from interface: `Graph`
      Returns the source vertex of an edge. For an undirected graph, source and target are distinguishable designations (but without any mathematical meaning).
      Specified by:
        `getEdgeSource` in interface `Graph<V,E>`
      Parameters:
        `e` - edge of interest
      Returns:
        source vertex

    - #### getEdgeTarget

          public V getEdgeTarget(E e)

      Description copied from interface: `Graph`
      Returns the target vertex of an edge. For an undirected graph, source and target are distinguishable designations (but without any mathematical meaning).
      Specified by:
        `getEdgeTarget` in interface `Graph<V,E>`
      Parameters:
        `e` - edge of interest
      Returns:
        target vertex

    - #### getEdgeWeight

          public double getEdgeWeight(E e)

      Description copied from interface: `Graph`
      Returns the weight assigned to a given edge. Unweighted graphs return 1.0 (as defined by `WeightedGraph.DEFAULT_EDGE_WEIGHT`), allowing weighted-graph algorithms to apply to them where meaningful.
      Specified by:
        `getEdgeWeight` in interface `Graph<V,E>`
      Parameters:
        `e` - edge of interest
      Returns:
        edge weight
      See Also:
        `WeightedGraph`

    - #### getG1

          public G getG1()

      Returns:
        G1

    - #### getG2

          public G getG2()

      Returns:
        G2

Copyright © 2016. All rights reserved.